#ifndef __CREATETASKFILE_H_INCLUDED__
#define __CREATETASKFILE_H_INCLUDED__

#include <syslog.h>
#include <string.h>

#define ERRORLOG(...) {openlog("CreateTaskFile", LOG_PID, LOG_LOCAL3); syslog(LOG_ERR, __VA_ARGS__); closelog(); }
#define DEBUGLOG_TASKD(...) {openlog("CreateTaskFile", LOG_PID, LOG_LOCAL3); syslog(LOG_DEBUG, __VA_ARGS__); closelog(); }


int createChildTask( const char * priorityType, const char * command, const char * type = NULL, const char * deltaType = NULL,
		 const char * jobID = NULL, const char * subjobID = NULL, const char * childID = NULL, const char * jobInfo = NULL, int relPriority = 0 );

int createTaskFile( const char * priorityType, const char * command, const char * type = NULL, const char * deltaType = NULL,
		 const char * jobID = NULL, const char * subjobID = NULL, const char * jobInfo = NULL, int relPriority = 0 );

/**
 * Generates a job ID.
 * The generated ID must be released by the caller
 *
 * @return  the generated job ID or NULL if an error occurred
 */
char * generateJobID( void );

int closeCreateTaskFile( void );



#endif								  // __CREATETASKFILE_H_INCLUDED__
