#ifndef __CREATETASKFILESO_H_INCLUDED__
#define __CREATETASKFILESO_H_INCLUDED__

#include <map>
#include <string>
#include <syslog.h>


using namespace std;



#define ERRORLOG(...) {openlog("CreateTaskFile", LOG_PID, LOG_LOCAL3); syslog(LOG_ERR, __VA_ARGS__); closelog(); }
#define DEBUGLOG_TASKD(...) {openlog("CreateTaskFile", LOG_PID, LOG_LOCAL3); syslog(LOG_DEBUG, __VA_ARGS__); closelog(); }

void __attribute__ ((constructor)) my_init(void);

class CreateTaskFile {
 private:

 public:

	 CreateTaskFile();
	 ~CreateTaskFile();

	 /**
	  * Generates an ID could be used as job ID.
	  * The returned job ID should be released by the caller
	  *
	  * @return  generated job ID or NULL if an error occurs
	  */
	 char * generateJobID();
	 bool createPriorityMap();
	 int createFile( const char * priorityType, const char * command, const char * type = NULL, const char * deltaType = NULL,
			 const char * jobID = NULL, const char * subjobID = NULL, const char * jobInfo = NULL, int relPriority = 0 );
};


#endif								  // __CREATETASKFILE_H_INCLUDED__
