/*
 * Component: taskd
 *
 * Description:
 *     Base class for so tasks
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 */
#ifndef __SOTASK_H_INCLUDED__
#define __SOTASK_H_INCLUDED__

#include <stdio.h>
#include <string.h>

#include "drwatson.h"

typedef struct {
	int nMaxRetryNum;
	int nMaxDelaySec;
	int nFirstDelaySec;
	int nIncreaseDelaySec;
	int nIncreaseDelayStep;
// derived
	int nRetryLimit;
} RETRY_PARAM;


class IMTask {
 private:
	RETRY_PARAM m_RetryParam;

 public:
	IMTask(const RETRY_PARAM & param) {
		memcpy(&m_RetryParam, &param, sizeof (RETRY_PARAM));
	}

	virtual ~IMTask() {
	}

	virtual int Run(int argc, char *argv[], int retry) = 0;

	virtual void Print(int argc, char *argv[]) {
		fprintf(stdout, "Unknown C task\n");
	}

	virtual void Cleanup(int argc, char * argv[]) {
		// Do nothing
	}


	virtual int CalcRetrySec(int retry) {
		if (m_RetryParam.nMaxRetryNum > 0 && retry >= m_RetryParam.nMaxRetryNum)
			return -1;

		int delay = m_RetryParam.nMaxDelaySec;

		if (retry <= m_RetryParam.nRetryLimit)
			delay =
					m_RetryParam.nFirstDelaySec +
					((retry / m_RetryParam.nIncreaseDelayStep) * m_RetryParam.nIncreaseDelaySec);

		return delay;
	}

	virtual DrWatson *GetWatsonMessage(int argc, char *argv[], int retry, int returncode) {
		return NULL;
	}
};

#endif								  // __SOTASK_H_INCLUDED__
