#ifndef MYTHREAD_H_INCLUDED__
#define MYTHREAD_H_INCLUDED__

#include <stdio.h>
#include <pthread.h>

void *Thread(void *arg);

class MyThread {
 private:

	pthread_t m_Thread;
	pthread_attr_t m_Attr;
	void *(*m_routine) (void *);
	void *m_arg;

 public:

	MyThread(void *(*routine) (void *), void *arg) {
		m_routine = routine;
		m_arg = arg;
	}
	
	~MyThread() {
	}

	int StartThread() {
		pthread_attr_init(&m_Attr);
		pthread_attr_setdetachstate(&m_Attr, PTHREAD_CREATE_DETACHED);
		return pthread_create(&m_Thread, &m_Attr, Thread, this);
	}

	void *Run() {
		return m_routine(m_arg);
	}

};

void Cleanup(void *arg);
void *Thread(void *arg);
MyThread *BeginMyThread(void *(*routine) (void *), void *arg);

#endif								  //MYTHREAD_H_INCLUDED__
