#ifndef _QUEUE_H_INCLUDED_
#define _QUEUE_H_INCLUDED_

#include <unistd.h>
#include <string>
#include <set>

using namespace std;

template < class T > class Comparator {
 public:
	inline bool operator()(const T * a, const T * b) const {
		return *a < *b;
	}
};

template < class T, class C = Comparator < T > >class Queue {
 private:
	set < T *, C > m_queue;

	typedef typename set < T *, C >::iterator Qiterator;

 public:
	Queue() {
	}

	~Queue() {
	}

	void Insert(T * key) {
		m_queue.insert(key);
	}

	T *RemoveFirst() {
		Qiterator iter = m_queue.begin();
		T *returnElem = NULL;

		if (iter != m_queue.end()) {
			returnElem = *iter;
			m_queue.erase(iter);
		}

		return returnElem;
	}

	T *GetFirst() {
		Qiterator iter = m_queue.begin();
		T *returnElem = NULL;

		if (iter != m_queue.end()) {
			returnElem = *iter;
		}

		return returnElem;
	}

	Qiterator GetFirstPosition() {
		return m_queue.begin();
	}

	T *GetNext(Qiterator & iter) {
		T *returnElem = NULL;

		if (iter != m_queue.end()) {
			returnElem = *iter;
			iter++;
		}
		return returnElem;
	}

	Qiterator Find(T * key) {
		return m_queue.find(key);
	}

	T *GetAt(Qiterator iter) {
		T *returnElem = NULL;

		if (iter != m_queue.end())
			returnElem = *iter;
		return returnElem;
	}

	T *RemoveAt(Qiterator iter) {
		T *returnElem = NULL;

		if (iter != m_queue.end()) {
			returnElem = *iter;
			m_queue.erase(iter);
		}
		return returnElem;
	}

	bool IsPositionNull(Qiterator iter) {
		return (iter == m_queue.end());
	}

	bool IsEmpty() {
		return m_queue.empty();
	}

	int GetCount() {
		return m_queue.size();
	}
};

#endif								  // _QUEUE_H_INCLUDED_
